<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <title>JSEOQ Testing Script</title>

    <!-- EOQ libraries -->
    <script src="../eoq2/query/query.js"></script>
    <script src="../eoq2/command/command.js"></script>
    <script src="../eoq2/eoq2.js"></script>
    <script src="../eoq2/util/logger.js"></script>
    <script src="../eoq2/command/result.js"></script>
    <script src="../eoq2/frame/frame.js"></script>
    <script src="../eoq2/event/event.js"></script>
    <script src="../eoq2/domain/domain.js"></script>
    <script src="../eoq2/serialization/serializer.js"></script>
    <script src="../eoq2/serialization/jsonserializer.js"></script>
    <script src="../eoq2/serialization/textserializer.js"></script>
    <script src="../eoq2/domain/remote/websocketdomain.js"></script>

    <!-- External library to render JSON in HTML -->
    <script src="js/renderjson.js"></script>

    <script src="contrib/jquery/jquery-3.3.1.min.js"></script>

    <!-- Testing Functions -->
    <script src="js/testing.js"></script>

    <link rel="stylesheet" type="text/css" href="css/jseoqdemo.css" />
</head>

<body onload="Start()">
    <h1 style="text-align: center;">JSEOQ Call Actions</h1>

    <div id="console" class="">
        <!-- all output goes here -->
    </div>

    <script>
        async function Start() {
            /*
            *   Template Code
            * */
            CreateStatusBlock();

            /*
            *   Test Related Code
            * */

            // settings
            let webSocketUrl = 'ws://localhost:8000/ws/eoq.do';
            let modelfile = "MinimalFlightControl.oaam";

            // initialize the domain
            UpdateStatusBlockOnlyText("Connecting to websocket...<br>", append = false);
            let domain = new eoq2.domain.remote.WebSocketDomain(webSocketUrl, logger = new eoq2.util.NoLogging());
            try {
                await domain.Open();
            }catch{
                UpdateStatusBlockOnlyText("No websocket available...<br>", append = false);
                SetStatusFailed();
            }

            // get domain root
            UpdateStatusBlockOnlyText("Getting root...<br>", append = true);
            root = await GetRoot(domain, modelfile);

            // initialize a new session
            UpdateStatusBlockOnlyText("Opening session...", append = true);
            let sessionId = await domain.Do(CMD.Hel('user', 'pw'));
            UpdateStatusBlockOnlyText("Obtained Session ID "+sessionId+" ...<br>", append = true);

            // define cmds
            let cmds = [
                CMD.Gaa(),
                // test sync call
                CMD.Cal('Misc/helloworld',[3]),
                CMD.Cal('Misc/helloworld',[3], ['silent',true,'eventsonly',true,'timeout',1+Number.EPSILON]), //timeout > 0.0 shall cause warning
                CMD.Cal('Misc/helloworld',[3], ['eventsonly',true]),
                CMD.Abc(1), //must fail: Can not abort sync calls
                // test async call
                CMD.Asc('Misc/helloworld',[3]),
                CMD.Asc('Misc/helloworld',[3], ['silent',true,'eventsonly',true,'timeout',1+Number.EPSILON]),
                CMD.Asc('Misc/helloworld',[3], ['eventsonly',true]),
                CMD.Asc('Misc/progress',[1,10]),
                CMD.Asc('Misc/progress',[1,10],['timeout',1+Number.EPSILON]),
                CMD.Cal('Misc/sleep',[10]), //wait some time
                // stop listening to events
                CMD.Cmp().Ses(sessionId).Ubs('*','*'),
                // test abort call
                CMD.Asc('Misc/progress',[1,10]),
                CMD.Cal('Misc/sleep',[4]), //wait some time
                CMD.Abc(9), //about after wait time
                CMD.Abc(3), //must fail: Call is already finished
                // test immediate abort
                CMD.Cmp().Asc('Misc/abortTest',[2]).Abc(QRY.His(0)),
                // test sync action output is async
                CMD.Cal('Misc/progress',[1,10]),
                // test nested calls
                CMD.Cmp().Asc('Misc/nestedcalls').Obs('OUP',QRY.His(0)),
                //finished
                CMD.Gby(sessionId)
            ]

            // testing
            let failedTests = [];
            UpdateStatusBlockOnlyText("Starting testing...", append = true);
            for (let testNr in cmds) {
                //console.log(testNr);
                let cmd = cmds[testNr];
                // run cmd
                // let result = await TestCommand(domain,cmd,testNr);
                TestCommand(domain, cmd, testNr).then(function (result) {
                    // correct test
                    PrintCmdInfo(cmd, testNr);
                    PrintResult(result, testNr);
                    // update status
                    UpdateStatusBlock(testNr, cmds, failedTests);
                }).catch(function (error) {
                    // failed test
                    PrintCmdInfo(cmd, testNr);
                    PrintFailedCmd(error, testNr);
                    failedTests = PushIfUnique(failedTests, testNr);
                    // update status
                    UpdateStatusBlock(testNr, cmds, failedTests);
                });
            }
        }
    </script>
</body>

</html>